// ***************************************************************************
// * ^Cg   : Ⴄ Java                                      *
// * o[W : Ver2.0                                                     *
// * 쌠     : Copyright (c) 2000                                         *
// *        :  ÕF                                                    *
// * Ж     : čύH[                                               *
// *        : Ⴄ Java Ver2.0                               *
// *              T[o (\lߋGZoj                           *
// ***************************************************************************

// ***************************************************************************
// *                                                                         *
// *                             XV                                    *
// *                                                                         *
// * (C) Yoshihiko Hara    2000.06.22 ō쐬(ALMANAC2NXƗ)       *
// *                                                                         *
// ***************************************************************************
package shinodas.netUra.server.cal;

import shinodas.netUra.server.cal.*;

public class Alm24{

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF Alm24                                                 *
	// *                                                                     *
	// *  @\      F RXgN^                                        *
	// *                                                                     *
	// *        F Ȃ                                                  *
	// *                                                                     *
	// *  o      F Ȃ                                                  *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.10.22    *
	// *                                                                     *
	// ***********************************************************************
	/**
		RXgN^B
	*/
	public Alm24(){
		;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF y2risyun                                              *
	// *                                                                     *
	// *  @\      F ^ꂽN̗t̓ij߂              *
	// *                                                                     *
	// *        F @ N(int)                                        *
	// *               A o(double)                                       *
	// *                                                                     *
	// *  o      F t̓(int)                                         *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.05.18    *
	// *                                                                     *
	// ***********************************************************************
	/**
		^ꂽN̗t̓ij߂B
		@param yyyy t߂悤ƂNijB
		@param lon  t߂悤Ƃꏊ̓oB
		@return t̓tB
	*/
	public int y2risyun(int yyyy,double lon){
		int ad_tbl_yyyy;     // A.DN
		int ad_tbl_mm;       // A.D
		int ad_tbl_dd;       // A.D
		double ad_tbl_time;  // A.D
		double ad_tbl_min;   // A.D
		double ad_tbl_sec;   // A.Db
		double ad_tbl_lon;   // o
		double jd;   		// EXʓ
		double ok;   		// z̉o
		int day; 			// t̓

		// t2/3`2/6̂ꂩłB
		// ɗt2/3ƂĂB
		day = 3;

		// z̗t̗(2/4)̃EXʓ߁A
		// Ƃɉo߂B
		ad_tbl_yyyy = yyyy;
		ad_tbl_mm   = 2;
		ad_tbl_dd   = 4;
		ad_tbl_time = 0;
		ad_tbl_min  = 0;
		ad_tbl_sec  = 0;
		ad_tbl_lon  = lon;

		JDChg  J  = new JDChg();
		AlmCal AC = new AlmCal();

		jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
				ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
		ok = AC.jd2sok(jd);

		// o315xȉȂA܂tł͂ȂB
		if(ok <= 315.0){

			// 2/4̗tƂB
			day++;

			// 2/5̉o߂B
			ad_tbl_dd = ad_tbl_dd + 1;
			jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
					ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
			ok = AC.jd2sok(jd);

			// o315xȉȂA܂tł͂ȂB
			if(ok <= 315.0){

				// 2/5̗tƂB
				day++;

				// 2/6̉o߂B
				ad_tbl_dd = ad_tbl_dd + 1;
				jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
						ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
				ok = AC.jd2sok(jd);

				// o315xȉȂ2/6tłB
				if(ok <= 315.0) day++;
			}
		}

		return day;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF y2usui                                                *
	// *                                                                     *
	// *  @\      F ^ꂽN̉J̓ij߂              *
	// *                                                                     *
	// *        F @ N(int)                                        *
	// *               A o(double)                                       *
	// *                                                                     *
	// *  o      F J̓(int)                                         *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.05.19    *
	// *                                                                     *
	// ***********************************************************************
	/**
		^ꂽN̉J̓ij߂B
		@param yyyy J߂悤ƂNijB
		@param lon  J߂悤Ƃꏊ̓oB
		@return J̓tB
	*/
	public int y2usui(int yyyy,double lon){

		int ad_tbl_yyyy;     // A.DN
		int ad_tbl_mm;       // A.D
		int ad_tbl_dd;       // A.D
		double ad_tbl_time;  // A.D
		double ad_tbl_min;   // A.D
		double ad_tbl_sec;   // A.Db
		double ad_tbl_lon;   // o
		double jd;   		// EXʓ
		double ok;   		// z̉o
		int day; 			// J̓

		// J2/17`2/20̂ꂩłB
		// 2/17ƂĂB
		day = 17;

		// (2/18)̃EXʓ߁A
		// Ƃɉo߂B
		ad_tbl_yyyy = yyyy;
		ad_tbl_mm   = 2;
		ad_tbl_dd   = 18;
		ad_tbl_time = 0;
		ad_tbl_min  = 0;
		ad_tbl_sec  = 0;
		ad_tbl_lon  = lon;

		JDChg  J  = new JDChg();
		AlmCal AC = new AlmCal();

		jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
				ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
		ok = AC.jd2sok(jd);
		// o330xȉȂA܂Jł͂ȂB
		if(ok <= 330.0){
			// 2/18̉JƍlA
			day++;
			// ̗(2/19)̃EXʓ^z̉o
			// ^̉Jǂ`FbNB
			ad_tbl_dd = ad_tbl_dd + 1;
			jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
					ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
			ok = AC.jd2sok(jd);
			// o330xȉȂA܂Jł͂ȂB
			if(ok <= 330.0){
				// 2/19̉JƍlA
				day++;
				// ̗(2/20)̃EXʓ^z̉o
				// ^̉Jǂ`FbNB
				ad_tbl_dd = ad_tbl_dd + 1;
				jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
						ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
				ok = AC.jd2sok(jd);
				// o330xȉȂA(2/20)JłB
				if(ok <= 330.0) day++;
			}
		}
		return day;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF y2ktitu                                               *
	// *                                                                     *
	// *  @\      F ^ꂽŇ[孂̓ij߂              *
	// *                                                                     *
	// *        F @ N(int)                                        *
	// *               A o(double)                                       *
	// *                                                                     *
	// *  o      F [孂̓(int)                                         *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.10.13    *
	// *                                                                     *
	// ***********************************************************************
	/**
		^ꂽŇ[孂̓ij߂B
		@param yyyy [孂߂悤ƂNijB
		@param lon  [孂߂悤Ƃꏊ̓oB
		@return [孂̓tB
	*/
	public int y2ktitu(int yyyy,double lon){
		int ad_tbl_yyyy;     // A.DN
		int ad_tbl_mm;       // A.D
		int ad_tbl_dd;       // A.D
		double ad_tbl_time;  // A.D
		double ad_tbl_min;   // A.D
		double ad_tbl_sec;   // A.Db
		double ad_tbl_lon;   // o
		double jd;   		// EXʓ
		double ok;   		// z̉o
		int day; 			// [孂̓
		// [孂3/4`3/7̂ꂩłB
		// 3/4ƂĂB
		day = 4;
		// (3/5)̃EXʓ߁A
		// Ƃɉo߂B
		ad_tbl_yyyy = yyyy;
		ad_tbl_mm   = 3;
		ad_tbl_dd   = 5;
		ad_tbl_time = 0;
		ad_tbl_min  = 0;
		ad_tbl_sec  = 0;
		ad_tbl_lon  = lon;

		JDChg  J  = new JDChg();
		AlmCal AC = new AlmCal();

		jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
				ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
		ok = AC.jd2sok(jd);
		// o345xȉȂA܂[孂ł͂ȂB
       if(ok <= 345.0){
		// 3/5̌[孂ƍlA
           day++;
			// ̗(3/6)̃EXʓ^z̉o
			// ^̌[孂ǂ`FbNB
			ad_tbl_dd = ad_tbl_dd + 1;
			jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
					ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
			ok = AC.jd2sok(jd);
			// o345xȉȂA܂[孂ł͂ȂB
			if(ok <= 345.0){
				// 3/6̌[孂ƍlA
				day++;
				// ̗(3/7)̃EXʓ^z̉o
				// ^̌[孂ǂ`FbNB
				ad_tbl_dd = ad_tbl_dd + 1;
				jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
						ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
				ok = AC.jd2sok(jd);
				// o345xȉȂA(3/7)[孂łB
				if(ok <= 345.0) day++;
			}
		}
		return day;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF y2syunbn                                              *
	// *                                                                     *
	// *  @\      F ^ꂽN̏t̓ij߂              *
	// *                                                                     *
	// *        F @ N(int)                                        *
	// *               A o(double)                                       *
	// *                                                                     *
	// *  o      F t̓(int)                                         *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.10.13    *
	// *                                                                     *
	// ***********************************************************************
	/**
		^ꂽN̏t̓ij߂B
		@param yyyy t߂悤ƂNijB
		@param lon  t߂悤Ƃꏊ̓oB
		@return t̓tB
	*/
	public int y2syunbn(int yyyy,double lon){
		int ad_tbl_yyyy;     // A.DN
		int ad_tbl_mm;       // A.D
		int ad_tbl_dd;       // A.D
		double ad_tbl_time;  // A.D
		double ad_tbl_min;   // A.D
		double ad_tbl_sec;   // A.Db
		double ad_tbl_lon;   // o
		double jd;   		// EXʓ
		double ok;   		// z̉o
		int day; 			// t̓
		// t3/19`3/22̂ꂩłB
		// 3/19ƂĂB
		day = 19;
		// (3/20)̃EXʓ߁A
		// Ƃɉo߂B
		ad_tbl_yyyy = yyyy;
		ad_tbl_mm   = 3;
		ad_tbl_dd   = 20;
		ad_tbl_time = 0;
		ad_tbl_min  = 0;
		ad_tbl_sec  = 0;
		ad_tbl_lon  = lon;

		JDChg  J  = new JDChg();
		AlmCal AC = new AlmCal();

		jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
				ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
		ok = AC.jd2sok(jd);
		// t̉o=0x(=360x)A
		// ߂Ă鉩óA345 < x < 15 ̊ԂłB
		// ߂ꂽo15xȉꍇ͕␳ĂB
		if(ok < 15.0) ok = ok + 360.0;
		// o360xȉȂA܂tł͂ȂB
		if(ok <= 360.0){
			// 3/20̏tƍlA
			day++;
			// ̗(3/21)̃EXʓ^z̉o
			// ^̏tǂ`FbNB
			ad_tbl_dd = ad_tbl_dd + 1;
			jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
   					ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
			ok = AC.jd2sok(jd);
			// t̉o=0x(=360x)A
			// ߂Ă鉩óA345 < x < 15 ̊ԂłB
			// ߂ꂽo15xȉꍇ͕␳ĂB
			if(ok < 15.0) ok = ok + 360.0;
			// o360xȉȂA܂tł͂ȂB
			if(ok <= 360.0){
				// 3/21̏tƍlA
				day++;
				// ̗(3/22)̃EXʓ^z̉o
				// ^̏tǂ`FbNB
				ad_tbl_dd = ad_tbl_dd + 1;
				jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
						ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
				ok = AC.jd2sok(jd);
				// t̉o=0x(=360x)A
				// ߂Ă鉩óA345 < x < 15 ̊ԂłB
				// ߂ꂽo15xȉꍇ͕␳ĂB
				if(ok < 15.0) ok = ok + 360.0;
				// o360xȉȂA(3/22)tłB
				if(ok <= 360.0) day++;
			}
		}
		return day;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF y2seimei                                              *
	// *                                                                     *
	// *  @\      F ^ꂽN̐̓ij߂              *
	// *                                                                     *
	// *        F @ N(int)                                        *
	// *               A o(double)                                       *
	// *                                                                     *
	// *  o      F ̓(int)                                         *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.10.13    *
	// *                                                                     *
	// ***********************************************************************
	/**
		^ꂽN̐̓ij߂B
		@param yyyy ߂悤ƂNijB
		@param lon  ߂悤Ƃꏊ̓oB
		@return ̓tB
	*/
	public int y2seimei(int yyyy,double lon){
		int ad_tbl_yyyy;     // A.DN
		int ad_tbl_mm;       // A.D
		int ad_tbl_dd;       // A.D
		double ad_tbl_time;  // A.D
		double ad_tbl_min;   // A.D
		double ad_tbl_sec;   // A.Db
		double ad_tbl_lon;   // o
		double jd;   		// EXʓ
		double ok;   		// z̉o
		int day; 			// ̓
		// 4/3`4/6̂ꂩłB
		// 4/3ƂĂB
		day = 3;
		// (4/4)̃EXʓ߁A
		// Ƃɉo߂B
		ad_tbl_yyyy = yyyy;
		ad_tbl_mm   = 4;
		ad_tbl_dd   = 4;
		ad_tbl_time = 0;
		ad_tbl_min  = 0;
		ad_tbl_sec  = 0;
		ad_tbl_lon  = lon;

		JDChg  J  = new JDChg();
		AlmCal AC = new AlmCal();

		jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
				ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
		ok = AC.jd2sok(jd);
		// o15xȉȂA܂ł͂ȂB
		if(ok <= 15.0){
			// 4/4̐ƍlA
			day++;
			// ̗(4/5)̃EXʓ^z̉o
			// ^̐ǂ`FbNB
			ad_tbl_dd = ad_tbl_dd + 1;
			jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
					ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
			ok = AC.jd2sok(jd);
			// o15xȉȂA܂ł͂ȂB
			if(ok <= 15.0){
				// 4/5̐ƍlA
				day++;
				// ̗(4/6)̃EXʓ^z̉o
				// ^̐ǂ`FbNB
				ad_tbl_dd = ad_tbl_dd + 1;
				jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
						ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
				ok = AC.jd2sok(jd);
				// o15xȉȂA(4/6)łB
				if(ok <= 15.0) day++;
			}
		}
		return day;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF y2kokuu                                               *
	// *                                                                     *
	// *  @\      F ^ꂽN̍J̓ij߂              *
	// *                                                                     *
	// *        F @ N(int)                                        *
	// *               A o(double)                                       *
	// *                                                                     *
	// *  o      F J̓(int)                                         *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.10.13    *
	// *                                                                     *
	// ***********************************************************************
	/**
		^ꂽN̍J̓ij߂B
		@param yyyy J߂悤ƂNijB
		@param lon  J߂悤Ƃꏊ̓oB
		@return J̓tB
	*/
	public int y2kokuu(int yyyy,double lon){
		int ad_tbl_yyyy;     // A.DN
		int ad_tbl_mm;       // A.D
		int ad_tbl_dd;       // A.D
		double ad_tbl_time;  // A.D
		double ad_tbl_min;   // A.D
		double ad_tbl_sec;   // A.Db
		double ad_tbl_lon;   // o
		double jd;   		// EXʓ
		double ok;   		// z̉o
		int day; 			// J̓
		// J4/19`4/22̂ꂩłB
		// 4/19ƂĂB
		day = 19;
		// (4/20)̃EXʓ߁A
		// Ƃɉo߂B
		ad_tbl_yyyy = yyyy;
		ad_tbl_mm   = 4;
		ad_tbl_dd   = 20;
		ad_tbl_time = 0;
		ad_tbl_min  = 0;
		ad_tbl_sec  = 0;
		ad_tbl_lon  = lon;

		JDChg  J  = new JDChg();
		AlmCal AC = new AlmCal();

		jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
				ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
		ok = AC.jd2sok(jd);
		// o30xȉȂA܂Jł͂ȂB
		if(ok <= 30.0){
			// 4/20̍JƍlA
			day++;
			// ̗(4/21)̃EXʓ^z̉o
			// ^̍Jǂ`FbNB
			ad_tbl_dd = ad_tbl_dd + 1;
			jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
					ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
			ok = AC.jd2sok(jd);
			// o30xȉȂA܂Jł͂ȂB
			if(ok <= 30.0){
				// 4/21̍JƍlA
				day++;
				// ̗(4/22)̃EXʓ^z̉o
				// ^̍Jǂ`FbNB
				ad_tbl_dd = ad_tbl_dd + 1;
				jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
						ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
				ok = AC.jd2sok(jd);
				// o30xȉȂA(4/22)JłB
				if(ok <= 30.0) day++;
			}
		}
		return day;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF y2rikka                                               *
	// *                                                                     *
	// *  @\      F ^ꂽN̗Ă̓ij߂              *
	// *                                                                     *
	// *        F @ N(int)                                        *
	// *               A o(double)                                       *
	// *                                                                     *
	// *  o      F Ă̓(int)                                         *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.10.13    *
	// *                                                                     *
	// ***********************************************************************
	/**
		^ꂽN̗Ă̓ij߂B
		@param yyyy Ă߂悤ƂNijB
		@param lon  Ă߂悤Ƃꏊ̓oB
		@return Ă̓tB
	*/
	public int y2rikka(int yyyy,double lon){
		int ad_tbl_yyyy;     // A.DN
		int ad_tbl_mm;       // A.D
		int ad_tbl_dd;       // A.D
		double ad_tbl_time;  // A.D
		double ad_tbl_min;   // A.D
		double ad_tbl_sec;   // A.Db
		double ad_tbl_lon;   // o
		double jd;   		// EXʓ
		double ok;   		// z̉o
		int day; 			// Ă̓
		// Ă5/4`5/7̂ꂩłB
		// 5/4ƂĂB
		day = 4;
		// (5/5)̃EXʓ߁A
		// Ƃɉo߂B
		ad_tbl_yyyy = yyyy;
		ad_tbl_mm   = 5;
		ad_tbl_dd   = 5;
		ad_tbl_time = 0;
		ad_tbl_min  = 0;
		ad_tbl_sec  = 0;
		ad_tbl_lon  = lon;

		JDChg  J  = new JDChg();
		AlmCal AC = new AlmCal();

		jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
				ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
		ok = AC.jd2sok(jd);
		// o45xȉȂA܂Ăł͂ȂB
		if(ok <= 45.0){
			// 5/5̗ĂƍlA
			day++;
			// ̗(5/6)̃EXʓ^z̉o
			// ^̗Ăǂ`FbNB
			ad_tbl_dd = ad_tbl_dd + 1;
			jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
					ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
			ok = AC.jd2sok(jd);
			// o45xȉȂA܂Ăł͂ȂB
			if(ok <= 45.0){
				// 5/6̗ĂƍlA
				day++;
				// ̗(5/7)̃EXʓ^z̉o
				// ^̗Ăǂ`FbNB
				ad_tbl_dd = ad_tbl_dd + 1;
				jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
						ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
				ok = AC.jd2sok(jd);
				// o45xȉȂA(5/7)ĂłB
				if(ok <= 45.0) day++;
			}
		}
		return day;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF y2syoman                                              *
	// *                                                                     *
	// *  @\      F ^ꂽN̏̓ij߂              *
	// *                                                                     *
	// *        F @ N(int)                                        *
	// *               A o(double)                                       *
	// *                                                                     *
	// *  o      F ̓(int)                                         *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.10.13    *
	// *                                                                     *
	// ***********************************************************************
	/**
		^ꂽN̏̓ij߂B
		@param yyyy ߂悤ƂNijB
		@param lon  ߂悤Ƃꏊ̓oB
		@return ̓tB
	*/
	public int y2syoman(int yyyy,double lon){
		int ad_tbl_yyyy;     // A.DN
		int ad_tbl_mm;       // A.D
		int ad_tbl_dd;       // A.D
		double ad_tbl_time;  // A.D
		double ad_tbl_min;   // A.D
		double ad_tbl_sec;   // A.Db
		double ad_tbl_lon;   // o
		double jd;   		// EXʓ
		double ok;   		// z̉o
		int day; 			// ̓
		// 5/19`5/22̂ꂩłB
		// 5/19ƂĂB
		day = 19;
		// (5/20)̃EXʓ߁A
		// Ƃɉo߂B
		ad_tbl_yyyy = yyyy;
		ad_tbl_mm   = 5;
		ad_tbl_dd   = 20;
		ad_tbl_time = 0;
		ad_tbl_min  = 0;
		ad_tbl_sec  = 0;
		ad_tbl_lon  = lon;

		JDChg  J  = new JDChg();
		AlmCal AC = new AlmCal();

		jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
				ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
		ok = AC.jd2sok(jd);
		// o60xȉȂA܂ł͂ȂB
		if(ok <= 60.0){
			// 5/20̏ƍlA
			day++;
			// ̗(5/21)̃EXʓ^z̉o
			// ^̏ǂ`FbNB
			ad_tbl_dd = ad_tbl_dd + 1;
			jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
					ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
			ok = AC.jd2sok(jd);
			// o60xȉȂA܂ł͂ȂB
			if(ok <= 60.0){
				// 5/21̏ƍlA
				day++;
				// ̗(5/22)̃EXʓ^z̉o
				// ^̏ǂ`FbNB
				ad_tbl_dd = ad_tbl_dd + 1;
				jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
						ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
				ok = AC.jd2sok(jd);
				// o60xȉȂA(5/22)łB
				if(ok <= 60.0) day++;
			}
		}
		return day;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF y2bousyu                                              *
	// *                                                                     *
	// *  @\      F ^ꂽN䊎̓ij߂              *
	// *                                                                     *
	// *        F @ N(int)                                        *
	// *               A o(double)                                       *
	// *                                                                     *
	// *  o      F 䊎̓(int)                                         *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.10.13    *
	// *                                                                     *
	// ***********************************************************************
	/**
		^ꂽN䊎̓ij߂B
		@param yyyy 䊎߂悤ƂNijB
		@param lon  䊎߂悤Ƃꏊ̓oB
		@return 䊎̓tB
	*/
	public int y2bousyu(int yyyy,double lon){
		int ad_tbl_yyyy;     // A.DN
		int ad_tbl_mm;       // A.D
		int ad_tbl_dd;       // A.D
		double ad_tbl_time;  // A.D
		double ad_tbl_min;   // A.D
		double ad_tbl_sec;   // A.Db
		double ad_tbl_lon;   // o
		double jd;   		// EXʓ
		double ok;   		// z̉o
		int day; 			// 䊎̓
		// 䊎6/4`6/7̂ꂩłB
		// 6/4ƂĂB
		day = 4;
		// (6/5)̃EXʓ߁A
		// Ƃɉo߂B
		ad_tbl_yyyy = yyyy;
		ad_tbl_mm   = 6;
		ad_tbl_dd   = 5;
		ad_tbl_time = 0;
		ad_tbl_min  = 0;
		ad_tbl_sec  = 0;
		ad_tbl_lon  = lon;

		JDChg  J  = new JDChg();
		AlmCal AC = new AlmCal();

		jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
				ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
		ok = AC.jd2sok(jd);
		// o75xȉȂA܂䊎ł͂ȂB
		if(ok <= 75.0){
			// 6/5䊎ƍlA
			day++;
			// ̗(6/6)̃EXʓ^z̉o
			// ^䊎킩ǂ`FbNB
			ad_tbl_dd = ad_tbl_dd + 1;
			jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
					ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
			ok = AC.jd2sok(jd);
			// o75xȉȂA܂䊎ł͂ȂB
			if(ok <= 75.0){
				// 6/6䊎ƍlA
				day++;
				// ̗(6/7)̃EXʓ^z̉o
				// ^䊎킩ǂ`FbNB
				ad_tbl_dd = ad_tbl_dd + 1;
				jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
						ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
				ok = AC.jd2sok(jd);
				// o75xȉȂA(6/7)䊎łB
				if(ok <= 75.0) day++;
			}
		}
		return day;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF y2gesi                                                *
	// *                                                                     *
	// *  @\      F ^ꂽN̉Ď̓ij߂              *
	// *                                                                     *
	// *        F @ N(int)                                        *
	// *               A o(double)                                       *
	// *                                                                     *
	// *  o      F Ď̓(int)                                         *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.10.13    *
	// *                                                                     *
	// ***********************************************************************
	/**
		^ꂽN̉Ď̓ij߂B
		@param yyyy Ď߂悤ƂNijB
		@param lon  Ď߂悤Ƃꏊ̓oB
		@return Ď̓tB
	*/
	public int y2gesi(int yyyy,double lon){
		int ad_tbl_yyyy;     // A.DN
		int ad_tbl_mm;       // A.D
		int ad_tbl_dd;       // A.D
		double ad_tbl_time;  // A.D
		double ad_tbl_min;   // A.D
		double ad_tbl_sec;   // A.Db
		double ad_tbl_lon;   // o
		double jd;   		// EXʓ
		double ok;   		// z̉o
		int day; 			// Ď̓
		// Ď6/20`6/23̂ꂩłB
		// 6/20ƂĂB
		day = 20;
		// (6/21)̃EXʓ߁A
		// Ƃɉo߂B
		ad_tbl_yyyy = yyyy;
		ad_tbl_mm   = 6;
		ad_tbl_dd   = 21;
		ad_tbl_time = 0;
		ad_tbl_min  = 0;
		ad_tbl_sec  = 0;
		ad_tbl_lon  = lon;

		JDChg  J  = new JDChg();
		AlmCal AC = new AlmCal();

		jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
				ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
		ok = AC.jd2sok(jd);
		// o90xȉȂA܂Ďł͂ȂB
		if(ok <= 90.0){
			// 6/21̉ĎƍlA
			day++;
			// ̗(6/22)̃EXʓ^z̉o
			// ^̉Ďǂ`FbNB
			ad_tbl_dd = ad_tbl_dd + 1;
			jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
					ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
			ok = AC.jd2sok(jd);
			// o90xȉȂA܂Ďł͂ȂB
			if(ok <= 90.0){
				// 6/22̉ĎƍlA
				day++;
				// ̗(6/23)̃EXʓ^z̉o
				// ^̉Ďǂ`FbNB
				ad_tbl_dd = ad_tbl_dd + 1;
				jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
						ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
				ok = AC.jd2sok(jd);
				// o90xȉȂA(6/23)ĎłB
				if(ok <= 90.0) day++;
			}
		}
		return day;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF y2syusyo                                              *
	// *                                                                     *
	// *  @\      F ^ꂽN̏̓ij߂              *
	// *                                                                     *
	// *        F @ N(int)                                        *
	// *               A o(double)                                       *
	// *                                                                     *
	// *  o      F ̓(int)                                         *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.10.13    *
	// *                                                                     *
	// ***********************************************************************
	/**
		^ꂽN̏̓ij߂B
		@param yyyy ߂悤ƂNijB
		@param lon  ߂悤Ƃꏊ̓oB
		@return ̓tB
	*/
	public int y2syusyo(int yyyy,double lon){
		int ad_tbl_yyyy;     // A.DN
		int ad_tbl_mm;       // A.D
		int ad_tbl_dd;       // A.D
		double ad_tbl_time;  // A.D
		double ad_tbl_min;   // A.D
		double ad_tbl_sec;   // A.Db
		double ad_tbl_lon;   // o
		double jd;   		// EXʓ
		double ok;   		// z̉o
		int day; 			// ̓
		// 7/5`7/8̂ꂩłB
		// 7/5ƂĂB
		day = 5;
		// (7/6)̃EXʓ߁A
		// Ƃɉo߂B
		ad_tbl_yyyy = yyyy;
		ad_tbl_mm   = 7;
		ad_tbl_dd   = 6;
		ad_tbl_time = 0;
		ad_tbl_min  = 0;
		ad_tbl_sec  = 0;
		ad_tbl_lon  = lon;

		JDChg  J  = new JDChg();
		AlmCal AC = new AlmCal();

		jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
				ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
		ok = AC.jd2sok(jd);
		// o105xȉȂA܂ł͂ȂB
		if(ok <= 105.0){
			// 7/6̏ƍlA
			day++;
			// ̗(7/7)̃EXʓ^z̉o
			// ^̏ǂ`FbNB
			ad_tbl_dd = ad_tbl_dd + 1;
			jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
					ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
			ok = AC.jd2sok(jd);
			// o105xȉȂA܂ł͂ȂB
			if(ok <= 105.0){
				// 7/7̏ƍlA
				day++;
				// ̗(7/8)̃EXʓ^z̉o
				// ^̏ǂ`FbNB
				ad_tbl_dd = ad_tbl_dd + 1;
				jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
						ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
				ok = AC.jd2sok(jd);
				// o105xȉȂA(7/8)łB
				if(ok <= 105.0) day++;
			}
		}
		return day;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF y2taisyo                                              *
	// *                                                                     *
	// *  @\      F ^ꂽN̑友̓ij߂              *
	// *                                                                     *
	// *        F @ N(int)                                        *
	// *               A o(double)                                       *
	// *                                                                     *
	// *  o      F 友̓(int)                                         *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.10.13    *
	// *                                                                     *
	// ***********************************************************************
	/**
		^ꂽN̑友̓ij߂B
		@param yyyy 友߂悤ƂNijB
		@param lon  友߂悤Ƃꏊ̓oB
		@return 友̓tB
	*/
	public int y2taisyo(int yyyy,double lon){
		int ad_tbl_yyyy;     // A.DN
		int ad_tbl_mm;       // A.D
		int ad_tbl_dd;       // A.D
		double ad_tbl_time;  // A.D
		double ad_tbl_min;   // A.D
		double ad_tbl_sec;   // A.Db
		double ad_tbl_lon;   // o
		double jd;   		// EXʓ
		double ok;   		// z̉o
		int day; 			// 友̓
		// 友7/21`7/24̂ꂩłB
		// 7/21ƂĂB
		day = 21;
		// (7/22)̃EXʓ߁A
		// Ƃɉo߂B
		ad_tbl_yyyy = yyyy;
		ad_tbl_mm   = 7;
		ad_tbl_dd   = 22;
		ad_tbl_time = 0;
		ad_tbl_min  = 0;
		ad_tbl_sec  = 0;
		ad_tbl_lon  = lon;

		JDChg  J  = new JDChg();
		AlmCal AC = new AlmCal();

		jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
				ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
		ok = AC.jd2sok(jd);
		// o120xȉȂA܂友ł͂ȂB
		if(ok <= 120.0){
			// 7/22̑友ƍlA
			day++;
			// ̗(7/23)̃EXʓ^z̉o
			// ^̑友ǂ`FbNB
			ad_tbl_dd = ad_tbl_dd + 1;
			jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
					ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
			ok = AC.jd2sok(jd);
			// o120xȉȂA܂友ł͂ȂB
			if(ok <= 120.0){
				// 7/23̑友ƍlA
				day++;
				// ̗(7/24)̃EXʓ^z̉o
				// ^̑友ǂ`FbNB
				ad_tbl_dd = ad_tbl_dd + 1;
				jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
						ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
				ok = AC.jd2sok(jd);
				// o120xȉȂA(7/24)友łB
				if(ok <= 120.0) day++;
			}
		}
		return day;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF y2risyuu                                              *
	// *                                                                     *
	// *  @\      F ^ꂽN̗H̓ij߂              *
	// *                                                                     *
	// *        F @ N(int)                                        *
	// *               A o(double)                                       *
	// *                                                                     *
	// *  o      F H̓(int)                                         *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.10.13    *
	// *                                                                     *
	// ***********************************************************************
	/**
		^ꂽN̗H̓ij߂B
		@param yyyy H߂悤ƂNijB
		@param lon  H߂悤Ƃꏊ̓oB
		@return H̓tB
	*/
	public int y2risyuu(int yyyy,double lon){
		int ad_tbl_yyyy;     // A.DN
		int ad_tbl_mm;       // A.D
		int ad_tbl_dd;       // A.D
		double ad_tbl_time;  // A.D
		double ad_tbl_min;   // A.D
		double ad_tbl_sec;   // A.Db
		double ad_tbl_lon;   // o
		double jd;   		// EXʓ
		double ok;   		// z̉o
		int day; 			// H̓
		// H8/6`8/9̂ꂩłB
		// 8/6ƂĂB
		day = 6;
		// (8/7)̃EXʓ߁A
		// Ƃɉo߂B
		ad_tbl_yyyy = yyyy;
		ad_tbl_mm   = 8;
		ad_tbl_dd   = 7;
		ad_tbl_time = 0;
		ad_tbl_min  = 0;
		ad_tbl_sec  = 0;
		ad_tbl_lon  = lon;

		JDChg  J  = new JDChg();
		AlmCal AC = new AlmCal();

		jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
				ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
		ok = AC.jd2sok(jd);
		// o135xȉȂA܂Hł͂ȂB
		if(ok <= 135.0){
			// 8/7̗HƍlA
			day++;
			// ̗(8/8)̃EXʓ^z̉o
			// ^̗Hǂ`FbNB
			ad_tbl_dd = ad_tbl_dd + 1;
			jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
					ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
			ok = AC.jd2sok(jd);
			// o135xȉȂA܂Hł͂ȂB
			if(ok <= 135.0){
				// 8/8̗HƍlA
				day++;
				// ̗(8/9)̃EXʓ^z̉o
				// ^̗Hǂ`FbNB
				ad_tbl_dd = ad_tbl_dd + 1;
				jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
						ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
				ok = AC.jd2sok(jd);
				// o135xȉȂA(8/9)HłB
				if(ok <= 135.0) day++;
			}
		}
		return day;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF y2syosyo                                              *
	// *                                                                     *
	// *  @\      F ^ꂽN̏̓ij߂              *
	// *                                                                     *
	// *        F @ N(int)                                        *
	// *               A o(double)                                       *
	// *                                                                     *
	// *  o      F ̓(int)                                         *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.10.13    *
	// *                                                                     *
	// ***********************************************************************
	/**
		^ꂽN̏̓ij߂B
		@param yyyy ߂悤ƂNijB
		@param lon  ߂悤Ƃꏊ̓oB
		@return ̓tB
	*/
	public int y2syosyo(int yyyy,double lon){
		int ad_tbl_yyyy;     // A.DN
		int ad_tbl_mm;       // A.D
		int ad_tbl_dd;       // A.D
		double ad_tbl_time;  // A.D
		double ad_tbl_min;   // A.D
		double ad_tbl_sec;   // A.Db
		double ad_tbl_lon;   // o
		double jd;   		// EXʓ
		double ok;   		// z̉o
		int day; 			// ̓
		// 8/21`8/24̂ꂩłB
		// 8/21ƂĂB
		day = 21;
		// (8/22)̃EXʓ߁A
		// Ƃɉo߂B
		ad_tbl_yyyy = yyyy;
		ad_tbl_mm   = 8;
		ad_tbl_dd   = 22;
		ad_tbl_time = 0;
		ad_tbl_min  = 0;
		ad_tbl_sec  = 0;
		ad_tbl_lon  = lon;

		JDChg  J  = new JDChg();
		AlmCal AC = new AlmCal();

		jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
				ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
		ok = AC.jd2sok(jd);
		// o150xȉȂA܂ł͂ȂB
		if(ok <= 150.0){
			// 8/22̏ƍlA
			day++;
			// ̗(8/23)̃EXʓ^z̉o
			// ^̏ǂ`FbNB
			ad_tbl_dd = ad_tbl_dd + 1;
			jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
					ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
			ok = AC.jd2sok(jd);
			// o150xȉȂA܂ł͂ȂB
			if(ok <= 150.0){
				// 8/23̏ƍlA
				day++;
				// ̗(8/24)̃EXʓ^z̉o
				// ^̏ǂ`FbNB
				ad_tbl_dd = ad_tbl_dd + 1;
				jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
						ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
				ok = AC.jd2sok(jd);
				// o150xȉȂA(8/24)łB
				if(ok <= 150.0) day++;
			}
		}
		return day;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF y2hakuro                                              *
	// *                                                                     *
	// *  @\      F ^ꂽN̔I̓ij߂              *
	// *                                                                     *
	// *        F @ N(int)                                        *
	// *               A o(double)                                       *
	// *                                                                     *
	// *  o      F I̓(int)                                         *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.10.13    *
	// *                                                                     *
	// ***********************************************************************
	/**
		^ꂽN̔I̓ij߂B
		@param yyyy I߂悤ƂNijB
		@param lon  I߂悤Ƃꏊ̓oB
		@return I̓tB
	*/
	public int y2hakuro(int yyyy,double lon){
		int ad_tbl_yyyy;     // A.DN
		int ad_tbl_mm;       // A.D
		int ad_tbl_dd;       // A.D
		double ad_tbl_time;  // A.D
		double ad_tbl_min;   // A.D
		double ad_tbl_sec;   // A.Db
		double ad_tbl_lon;   // o
		double jd;   		// EXʓ
		double ok;   		// z̉o
		int day; 			// I̓
		// I9/6`9/9̂ꂩłB
		// 9/6ƂĂB
		day = 6;
		// (9/7)̃EXʓ߁A
		// Ƃɉo߂B
		ad_tbl_yyyy = yyyy;
		ad_tbl_mm   = 9;
		ad_tbl_dd   = 7;
		ad_tbl_time = 0;
		ad_tbl_min  = 0;
		ad_tbl_sec  = 0;
		ad_tbl_lon  = lon;

		JDChg  J  = new JDChg();
		AlmCal AC = new AlmCal();

		jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
				ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
		ok = AC.jd2sok(jd);
		// o165xȉȂA܂Ił͂ȂB
		if(ok <= 165.0){
			// 9/7̔IƍlA
			day++;
			// ̗(9/8)̃EXʓ^z̉o
			// ^̔Iǂ`FbNB
			ad_tbl_dd = ad_tbl_dd + 1;
			jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
					ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
			ok = AC.jd2sok(jd);
			// o165xȉȂA܂Ił͂ȂB
			if(ok <= 165.0){
				// 9/8̔IƍlA
				day++;
				// ̗(9/9)̃EXʓ^z̉o
				// ^̔Iǂ`FbNB
				ad_tbl_dd = ad_tbl_dd + 1;
				jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
						ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
				ok = AC.jd2sok(jd);
				// o165xȉȂA(9/9)IłB
				if(ok <= 165.0) day++;
			}
		}
		return day;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF y2syuubn                                              *
	// *                                                                     *
	// *  @\      F ^ꂽN̏H̓ij߂              *
	// *                                                                     *
	// *        F @ N(int)                                        *
	// *               A o(double)                                       *
	// *                                                                     *
	// *  o      F H̓(int)                                         *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.10.13    *
	// *                                                                     *
	// ***********************************************************************
	/**
		^ꂽN̏H̓ij߂B
		@param yyyy H߂悤ƂNijB
		@param lon  H߂悤Ƃꏊ̓oB
		@return H̓tB
	*/
	public int y2syuubn(int yyyy,double lon){
		int ad_tbl_yyyy;     // A.DN
		int ad_tbl_mm;       // A.D
		int ad_tbl_dd;       // A.D
		double ad_tbl_time;  // A.D
		double ad_tbl_min;   // A.D
		double ad_tbl_sec;   // A.Db
		double ad_tbl_lon;   // o
		double jd;   		// EXʓ
		double ok;   		// z̉o
		int day; 			// H̓
		// H9/21`9/24̂ꂩłB
		// 9/21ƂĂB
		day = 21;
		// (9/22)̃EXʓ߁A
		// Ƃɉo߂B
		ad_tbl_yyyy = yyyy;
		ad_tbl_mm   = 9;
		ad_tbl_dd   = 22;
		ad_tbl_time = 0;
		ad_tbl_min  = 0;
		ad_tbl_sec  = 0;
		ad_tbl_lon  = lon;

		JDChg  J  = new JDChg();
		AlmCal AC = new AlmCal();

		jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
				ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
		ok = AC.jd2sok(jd);
		// o180xȉȂA܂Hł͂ȂB
		if(ok <= 180.0){
			// 9/22̏HƍlA
			day++;
			// ̗(9/23)̃EXʓ^z̉o
			// ^̏Hǂ`FbNB
			ad_tbl_dd = ad_tbl_dd + 1;
			jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
					ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
			ok = AC.jd2sok(jd);
			// o180xȉȂA܂Hł͂ȂB
			if(ok <= 180.0){
				// 9/23̏HƍlA
				day++;
				// ̗(9/24)̃EXʓ^z̉o
				// ^̏Hǂ`FbNB
				ad_tbl_dd = ad_tbl_dd + 1;
				jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
						ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
				ok = AC.jd2sok(jd);
				// o180xȉȂA(9/24)HłB
				if(ok <= 180.0) day++;
			}
		}
		return day;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF y2kanro                                               *
	// *                                                                     *
	// *  @\      F ^ꂽN̊I̓ij߂              *
	// *                                                                     *
	// *        F @ N(int)                                        *
	// *               A o(double)                                       *
	// *                                                                     *
	// *  o      F I̓(int)                                         *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.10.13    *
	// *                                                                     *
	// ***********************************************************************
	/**
		^ꂽN̊I̓ij߂B
		@param yyyy I߂悤ƂNijB
		@param lon  I߂悤Ƃꏊ̓oB
		@return I̓tB
	*/
	public int y2kanro(int yyyy,double lon){
		int ad_tbl_yyyy;     // A.DN
		int ad_tbl_mm;       // A.D
		int ad_tbl_dd;       // A.D
		double ad_tbl_time;  // A.D
		double ad_tbl_min;   // A.D
		double ad_tbl_sec;   // A.Db
		double ad_tbl_lon;   // o
		double jd;   		// EXʓ
		double ok;   		// z̉o
		int day; 			// I̓
		// I10/6`10/9̂ꂩłB
		// 10/6ƂĂB
		day = 6;
		// (10/7)̃EXʓ߁A
		// Ƃɉo߂B
		ad_tbl_yyyy = yyyy;
		ad_tbl_mm   = 10;
		ad_tbl_dd   = 7;
		ad_tbl_time = 0;
		ad_tbl_min  = 0;
		ad_tbl_sec  = 0;
		ad_tbl_lon  = lon;

		JDChg  J  = new JDChg();
		AlmCal AC = new AlmCal();

		jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
   				ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
		ok = AC.jd2sok(jd);
		// o195xȉȂA܂Ił͂ȂB
		if(ok <= 195.0){
			// 10/7̊IƍlA
			day++;
			// ̗(10/8)̃EXʓ^z̉o
			// ^̊Iǂ`FbNB
			ad_tbl_dd = ad_tbl_dd + 1;
			jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
					ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
			ok = AC.jd2sok(jd);
			// o195xȉȂA܂Ił͂ȂB
			if(ok <= 195.0){
				// 10/8̊IƍlA
				day++;
				// ̗(10/9)̃EXʓ^z̉o
				// ^̊Iǂ`FbNB
				ad_tbl_dd = ad_tbl_dd + 1;
				jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
						ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
				ok = AC.jd2sok(jd);
 				// o195xȉȂA(10/9)IłB
				if(ok <= 195.0) day++;
			}
		}
		return day;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF y2soukou                                              *
	// *                                                                     *
	// *  @\      F ^ꂽN̑~̓ij߂              *
	// *                                                                     *
	// *        F @ N(int)                                        *
	// *               A o(double)                                       *
	// *                                                                     *
	// *  o      F ~̓(int)                                         *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.10.13    *
	// *                                                                     *
	// ***********************************************************************
	/**
		^ꂽN̑~̓ij߂B
		@param yyyy ~߂悤ƂNijB
		@param lon  ~߂悤Ƃꏊ̓oB
		@return ~̓tB
	*/
	public int y2soukou(int yyyy,double lon){
		int ad_tbl_yyyy;     // A.DN
		int ad_tbl_mm;       // A.D
		int ad_tbl_dd;       // A.D
		double ad_tbl_time;  // A.D
		double ad_tbl_min;   // A.D
		double ad_tbl_sec;   // A.Db
		double ad_tbl_lon;   // o
		double jd;   		// EXʓ
		double ok;   		// z̉o
		int day; 			// ~̓
		// ~10/22`10/25̂ꂩłB
		// 10/22ƂĂB
		day = 22;
		// (10/23)̃EXʓ߁A
		// Ƃɉo߂B
		ad_tbl_yyyy = yyyy;
		ad_tbl_mm   = 10;
		ad_tbl_dd   = 23;
		ad_tbl_time = 0;
		ad_tbl_min  = 0;
		ad_tbl_sec  = 0;
		ad_tbl_lon  = lon;

		JDChg  J  = new JDChg();
		AlmCal AC = new AlmCal();

		jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
				ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
		ok = AC.jd2sok(jd);
		// o210xȉȂA܂~ł͂ȂB
		if(ok <= 210.0){
			// 10/23̑~ƍlA
			day++;
			// ̗(10/24)̃EXʓ^z̉o
			// ^̑~ǂ`FbNB
			ad_tbl_dd = ad_tbl_dd + 1;
			jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
					ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
			ok = AC.jd2sok(jd);
			// o210xȉȂA܂~ł͂ȂB
			if(ok <= 210.0){
				// 10/24̑~ƍlA
				day++;
				// ̗(10/25)̃EXʓ^z̉o
				// ^̑~ǂ`FbNB
				ad_tbl_dd = ad_tbl_dd + 1;
				jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
						ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
				ok = AC.jd2sok(jd);
				// o210xȉȂA(10/25)~łB
				if(ok <= 210.0) day++;
			}
		}
		return day;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF y2rittou                                              *
	// *                                                                     *
	// *  @\      F ^ꂽN̗~̓ij߂              *
	// *                                                                     *
	// *        F @ N(int)                                        *
	// *               A o(double)                                       *
	// *                                                                     *
	// *  o      F ~̓(int)                                         *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.10.13    *
	// *                                                                     *
	// ***********************************************************************
	/**
		^ꂽN̗~̓ij߂B
		@param yyyy ~߂悤ƂNijB
		@param lon  ~߂悤Ƃꏊ̓oB
		@return ~̓tB
	*/
	public int y2rittou(int yyyy,double lon){
		int ad_tbl_yyyy;     // A.DN
		int ad_tbl_mm;       // A.D
		int ad_tbl_dd;       // A.D
		double ad_tbl_time;  // A.D
		double ad_tbl_min;   // A.D
		double ad_tbl_sec;   // A.Db
		double ad_tbl_lon;   // o
		double jd;   		// EXʓ
		double ok;   		// z̉o
		int day; 			// ~̓
		// ~11/6`11/9̂ꂩłB
		// 11/6ƂĂB
		day = 6;
		// (11/7)̃EXʓ߁A
		// Ƃɉo߂B
		ad_tbl_yyyy = yyyy;
		ad_tbl_mm   = 11;
		ad_tbl_dd   = 7;
		ad_tbl_time = 0;
		ad_tbl_min  = 0;
		ad_tbl_sec  = 0;
		ad_tbl_lon  = lon;

		JDChg  J  = new JDChg();
		AlmCal AC = new AlmCal();

		jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
				ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
		ok = AC.jd2sok(jd);
		// o225xȉȂA܂~ł͂ȂB
		if(ok <= 225.0){
			// 11/7̗~ƍlA
			day++;
			// ̗(11/8)̃EXʓ^z̉o
			// ^̗~ǂ`FbNB
			ad_tbl_dd = ad_tbl_dd + 1;
			jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
					ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
			ok = AC.jd2sok(jd);
			// o225xȉȂA܂~ł͂ȂB
			if(ok <= 225.0){
				// 11/8̗~ƍlA
				day++;
				// ̗(11/9)̃EXʓ^z̉o
				// ^̗~ǂ`FbNB
				ad_tbl_dd = ad_tbl_dd + 1;
				jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
						ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
				ok = AC.jd2sok(jd);
				// o225xȉȂA(11/9)~łB
				if(ok <= 225.0) day++;
			}
		}
		return day;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF y2syostu                                              *
	// *                                                                     *
	// *  @\      F ^ꂽN̏̓ij߂              *
	// *                                                                     *
	// *        F @ N(int)                                        *
	// *               A o(double)                                       *
	// *                                                                     *
	// *  o      F ̓(int)                                         *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.10.13    *
	// *                                                                     *
	// ***********************************************************************
	/**
		^ꂽN̏̓ij߂B
		@param yyyy ߂悤ƂNijB
		@param lon  ߂悤Ƃꏊ̓oB
		@return ̓tB
	*/
	public int y2syostu(int yyyy,double lon){
		int ad_tbl_yyyy;     // A.DN
		int ad_tbl_mm;       // A.D
		int ad_tbl_dd;       // A.D
		double ad_tbl_time;  // A.D
		double ad_tbl_min;   // A.D
		double ad_tbl_sec;   // A.Db
		double ad_tbl_lon;   // o
		double jd;   		// EXʓ
		double ok;   		// z̉o
		int day; 			// ̓
		// 11/21`11/24̂ꂩłB
		// 11/21ƂĂB
		day = 21;
		// (11/22)̃EXʓ߁A
		// Ƃɉo߂B
		ad_tbl_yyyy = yyyy;
		ad_tbl_mm   = 11;
		ad_tbl_dd   = 22;
		ad_tbl_time = 0;
		ad_tbl_min  = 0;
		ad_tbl_sec  = 0;
		ad_tbl_lon  = lon;

		JDChg  J  = new JDChg();
		AlmCal AC = new AlmCal();

		jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
				ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
		ok = AC.jd2sok(jd);
		// o240xȉȂA܂ł͂ȂB
		if(ok <= 240.0){
			// 11/22̏ƍlA
			day++;
			// ̗(11/23)̃EXʓ^z̉o
			// ^̏Ⴉǂ`FbNB
			ad_tbl_dd = ad_tbl_dd + 1;
			jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
					ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
			ok = AC.jd2sok(jd);
			// o240xȉȂA܂ł͂ȂB
			if(ok <= 240.0){
				// 11/23̗~ƍlA
				day++;
				// ̗(11/24)̃EXʓ^z̉o
				// ^̏Ⴉǂ`FbNB
				ad_tbl_dd = ad_tbl_dd + 1;
				jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
						ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
				ok = AC.jd2sok(jd);
				// o240xȉȂA(11/24)łB
				if(ok <= 240.0) day++;
			}
		}
		return day;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF y2taistu                                              *
	// *                                                                     *
	// *  @\      F ^ꂽN̑̓ij߂              *
	// *                                                                     *
	// *        F @ N(int)                                        *
	// *               A o(double)                                       *
	// *                                                                     *
	// *  o      F ̓(int)                                         *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.10.13    *
	// *                                                                     *
	// ***********************************************************************
	/**
		^ꂽN̑̓ij߂B
		@param yyyy ߂悤ƂNijB
		@param lon  ߂悤Ƃꏊ̓oB
		@return ̓tB
	*/
	public int y2taistu(int yyyy,double lon){
		int ad_tbl_yyyy;     // A.DN
		int ad_tbl_mm;       // A.D
		int ad_tbl_dd;       // A.D
		double ad_tbl_time;  // A.D
		double ad_tbl_min;   // A.D
		double ad_tbl_sec;   // A.Db
		double ad_tbl_lon;   // o
		double jd;   		// EXʓ
		double ok;   		// z̉o
		int day; 			// ̓
		// 12/5`12/8̂ꂩłB
		// 12/5ƂĂB
		day = 5;
		// (12/6)̃EXʓ߁A
		// Ƃɉo߂B
		ad_tbl_yyyy = yyyy;
		ad_tbl_mm   = 12;
		ad_tbl_dd   = 6;
		ad_tbl_time = 0;
		ad_tbl_min  = 0;
		ad_tbl_sec  = 0;
		ad_tbl_lon  = lon;

		JDChg  J  = new JDChg();
		AlmCal AC = new AlmCal();

		jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
				ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
		ok = AC.jd2sok(jd);
		// o255xȉȂA܂ł͂ȂB
		if(ok <= 255.0){
			// 12/6̑ƍlA
			day++;
			// ̗(12/7)̃EXʓ^z̉o
			// ^̑Ⴉǂ`FbNB
			ad_tbl_dd = ad_tbl_dd + 1;
			jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
					ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
			ok = AC.jd2sok(jd);
			// o255xȉȂA܂ł͂ȂB
			if(ok <= 255.0){
				// 12/7̑ƍlA
				day++;
				// ̗(12/8)̃EXʓ^z̉o
				// ^̑Ⴉǂ`FbNB
				ad_tbl_dd = ad_tbl_dd + 1;
				jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
						ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
				ok = AC.jd2sok(jd);
				// o255xȉȂA(12/8)łB
				if(ok <= 255.0) day++;
			}
		}
		return day;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF y2touji                                               *
	// *                                                                     *
	// *  @\      F ^ꂽN̓~̓ij߂              *
	// *                                                                     *
	// *        F @ N(int)                                        *
	// *               A o(double)                                       *
	// *                                                                     *
	// *  o      F ~̓(int)                                         *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.10.13    *
	// *                                                                     *
	// ***********************************************************************
	/**
		^ꂽN̓~̓ij߂B
		@param yyyy ~߂悤ƂNijB
		@param lon  ~߂悤Ƃꏊ̓oB
		@return ~̓tB
	*/
	public int y2touji(int yyyy,double lon){
		int ad_tbl_yyyy;     // A.DN
		int ad_tbl_mm;       // A.D
		int ad_tbl_dd;       // A.D
		double ad_tbl_time;  // A.D
		double ad_tbl_min;   // A.D
		double ad_tbl_sec;   // A.Db
		double ad_tbl_lon;   // o
		double jd;   		// EXʓ
		double ok;   		// z̉o
		int day; 			// ~̓
		// ~12/20`12/23̂ꂩłB
		// 12/20ƂĂB
		day = 20;
		// (12/21)̃EXʓ߁A
		// Ƃɉo߂B
		ad_tbl_yyyy = yyyy;
		ad_tbl_mm   = 12;
		ad_tbl_dd   = 21;
		ad_tbl_time = 0;
		ad_tbl_min  = 0;
		ad_tbl_sec  = 0;
		ad_tbl_lon  = lon;

		JDChg  J  = new JDChg();
		AlmCal AC = new AlmCal();

		jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
				ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
		ok = AC.jd2sok(jd);
		// o270xȉȂA܂~ł͂ȂB
		if(ok <= 270.0){
			// 12/21̓~ƍlA
			day++;
			// ̗(12/22)̃EXʓ^z̉o
			// ^̓~ǂ`FbNB
			ad_tbl_dd = ad_tbl_dd + 1;
			jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
					ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
			ok = AC.jd2sok(jd);
			// o270xȉȂA܂~ł͂ȂB
			if(ok <= 270.0){
				// 12/22̓~ƍlA
				day++;
				// ̗(12/23)̃EXʓ^z̉o
				// ^̓~ǂ`FbNB
				ad_tbl_dd = ad_tbl_dd + 1;
				jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
						ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
				ok = AC.jd2sok(jd);
				// o270xȉȂA(12/23)~łB
				if(ok <= 270.0) day++;
			}
		}
		return day;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF y2syokan                                              *
	// *                                                                     *
	// *  @\      F ^ꂽN̏̓ij߂              *
	// *                                                                     *
	// *        F @ N(int)                                        *
	// *               A o(double)                                       *
	// *                                                                     *
	// *  o      F ̓(int)                                         *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.10.13    *
	// *                                                                     *
	// ***********************************************************************
	/**
		^ꂽN̏̓ij߂B
		@param yyyy ߂悤ƂNijB
		@param lon  ߂悤Ƃꏊ̓oB
		@return ̓tB
	*/
	public int y2syokan(int yyyy,double lon){
		int ad_tbl_yyyy;     // A.DN
		int ad_tbl_mm;       // A.D
		int ad_tbl_dd;       // A.D
		double ad_tbl_time;  // A.D
		double ad_tbl_min;   // A.D
		double ad_tbl_sec;   // A.Db
		double ad_tbl_lon;   // o
		double jd;   		// EXʓ
		double ok;   		// z̉o
		int day; 			// ̓
		// 1/4`1/7̂ꂩłB
		// 1/4ƂĂB
		day = 4;
		// (1/5)̃EXʓ߁A
		// Ƃɉo߂B
		ad_tbl_yyyy = yyyy;
		ad_tbl_mm   = 1;
		ad_tbl_dd   = 5;
		ad_tbl_time = 0;
		ad_tbl_min  = 0;
		ad_tbl_sec  = 0;
		ad_tbl_lon  = lon;

		JDChg  J  = new JDChg();
		AlmCal AC = new AlmCal();

		jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
				ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
		ok = AC.jd2sok(jd);
		// o285xȉȂA܂ł͂ȂB
		if(ok <= 285.0){
			// 1/5̏ƍlA
			day++;
			// ̗(1/6)̃EXʓ^z̉o
			// ^̏ǂ`FbNB
			ad_tbl_dd = ad_tbl_dd + 1;
			jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
					ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
			ok = AC.jd2sok(jd);
			// o285xȉȂA܂ł͂ȂB
			if(ok <= 285.0){
				// 1/6̏ƍlA
				day++;
				// ̗(1/7)̃EXʓ^z̉o
				// ^̏ǂ`FbNB
				ad_tbl_dd = ad_tbl_dd + 1;
				jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
						ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
				ok = AC.jd2sok(jd);
				// o285xȉȂA(1/7)łB
				if(ok <= 285.0) day++;
			}
		}
		return day;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF y2taikan                                              *
	// *                                                                     *
	// *  @\      F ^ꂽN̑劦̓ij߂              *
	// *                                                                     *
	// *        F @ N(int)                                        *
	// *               A o(double)                                       *
	// *                                                                     *
	// *  o      F 劦̓(int)                                         *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.10.13    *
	// *                                                                     *
	// ***********************************************************************
	/**
		^ꂽN̑劦̓ij߂B
		@param yyyy 劦߂悤ƂNijB
		@param lon  劦߂悤Ƃꏊ̓oB
		@return 劦̓tB
	*/
	public int y2taikan(int yyyy,double lon){
		int ad_tbl_yyyy;     // A.DN
		int ad_tbl_mm;       // A.D
		int ad_tbl_dd;       // A.D
		double ad_tbl_time;  // A.D
		double ad_tbl_min;   // A.D
		double ad_tbl_sec;   // A.Db
		double ad_tbl_lon;   // o
		double jd;   		// EXʓ
		double ok;   		// z̉o
		int day; 			// 劦̓
		// 劦1/19`1/22̂ꂩłB
		// 1/19ƂĂB
		day = 19;
		// (1/20)̃EXʓ߁A
		// Ƃɉo߂B
		ad_tbl_yyyy = yyyy;
		ad_tbl_mm   = 1;
		ad_tbl_dd   = 20;
		ad_tbl_time = 0;
		ad_tbl_min  = 0;
		ad_tbl_sec  = 0;
		ad_tbl_lon  = lon;

		JDChg  J  = new JDChg();
		AlmCal AC = new AlmCal();

		jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
				ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
		ok = AC.jd2sok(jd);
		// o300xȉȂA܂劦ł͂ȂB
		if(ok <= 300.0){
			// 1/20̑劦ƍlA
			day++;
			// ̗(1/21)̃EXʓ^z̉o
			// ^̑劦ǂ`FbNB
			ad_tbl_dd = ad_tbl_dd + 1;
			jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
					ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
			ok = AC.jd2sok(jd);
			// o300xȉȂA܂劦ł͂ȂB
			if(ok <= 300.0){
				// 1/21̑劦ƍlA
				day++;
				// ̗(1/22)̃EXʓ^z̉o
				// ^̑劦ǂ`FbNB
				ad_tbl_dd = ad_tbl_dd + 1;
				jd = J.ad2jd(ad_tbl_yyyy,ad_tbl_mm,ad_tbl_dd,ad_tbl_time,
						ad_tbl_min,ad_tbl_sec,ad_tbl_lon);
				ok = AC.jd2sok(jd);
 				// o300xȉȂA(1/22)劦łB
				if(ok <= 300.0) day++;
			}
		}
		return day;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF ad2setu                                               *
	// *                                                                     *
	// *  @\      F ߓ̌oߓ߂                            *
	// *                                                                     *
	// *        F @ A.DN(int)                                         *
	// *               A A.D(int)                                         *
	// *               B A.D(int)                                         *
	// *               C A.D(double)                                      *
	// *               D A.D(double)                                      *
	// *               E A.Db(double)                                      *
	// *               F o(double)                                       *
	// *                                                                     *
	// *  o      F oߓ(int)                                         *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.09.24    *
	// *                                                                     *
	// ***********************************************************************
	/**
		ߓ̌oߓ߂B
		@param yyyy oߓ߂悤ƂNijB
		@param mm   oߓ߂悤Ƃ錎ijB
		@param dd   oߓ߂悤ƂijB
		@param time oߓ߂悤Ƃ鎞ijB
		@param min  oߓ߂悤Ƃ镪ijB
		@param sec  oߓ߂悤ƂbijB
		@param lon  oߓ߂悤Ƃꏊ̓oB
		@return oߓB
	*/
	public int ad2setu(int yyyy,     // A.DN
					   int mm,       // A.D
					   int dd,       // A.D
					   double time,  // A.D
					   double min,   // A.D
					   double sec,   // A.Db
					   double lon){  // o

		// Yޔp[N
		int ad_tbl_yyyy;     // [NA.DN
		int ad_tbl_mm;       // [NA.D
		int ad_tbl_dd;       // [NA.D
		double ad_tbl_time;  // [NA.D
		double ad_tbl_min;   // [NA.D
		double ad_tbl_sec;   // [NA.Db
		double ad_tbl_lon;   // [No

		// ߓZop[N
		int ad_tbl2_yyyy    = 0;    // [NA.DN
		int ad_tbl2_mm      = 0;    // [NA.D
		int ad_tbl2_dd      = 0;    // [NA.D
		double ad_tbl2_time = 0.0;  // [NA.D
		double ad_tbl2_min  = 0.0;  // [NA.D
		double ad_tbl2_sec  = 0.0;  // [NA.Db
		double ad_tbl2_lon  = 0.0;  // [No

		double Whi;   		// dataZo[N
		int hi ;  			// datai[[N

		// Yޔ
		ad_tbl_yyyy = ad_tbl2_yyyy = yyyy;
		ad_tbl_mm   = ad_tbl2_mm   = mm;
		ad_tbl_dd   = ad_tbl2_dd   = dd;
		ad_tbl_time = ad_tbl2_time = time;
		ad_tbl_min  = ad_tbl2_min  = min;
		ad_tbl_sec  = ad_tbl2_sec  = sec;
		ad_tbl_lon  = ad_tbl2_lon  = lon;

		// YȑO̐ߓ߂
        switch(mm){
		case 1:
			ad_tbl2_dd = y2syokan(ad_tbl2_yyyy,ad_tbl2_lon);
			if(ad_tbl2_dd > dd){
				ad_tbl2_lon  = lon;
				ad_tbl2_yyyy = ad_tbl2_yyyy - 1;
				ad_tbl2_mm   = 12;
				ad_tbl2_dd   = y2taistu(ad_tbl2_yyyy,ad_tbl2_lon);
			}
			break;
		case 2:
			ad_tbl2_dd = y2risyun(ad_tbl2_yyyy,ad_tbl2_lon);
			if(ad_tbl2_dd > dd){
				ad_tbl2_lon  = lon;
				ad_tbl2_yyyy = yyyy;
				ad_tbl2_mm   = 1;
				ad_tbl2_dd   = y2syokan(ad_tbl2_yyyy,ad_tbl2_lon);
			}
			break;
		case 3:
			ad_tbl2_dd = y2ktitu(ad_tbl2_yyyy,ad_tbl2_lon);
			if(ad_tbl2_dd > dd){
				ad_tbl2_lon  = lon;
				ad_tbl2_yyyy = yyyy;
				ad_tbl2_mm   = 2;
				ad_tbl2_dd   = y2risyun(ad_tbl2_yyyy,ad_tbl2_lon);
			}
			break;
		case 4:
			ad_tbl2_dd = y2seimei(ad_tbl2_yyyy,ad_tbl2_lon);
			if(ad_tbl2_dd > dd){
				ad_tbl2_lon  = lon;
				ad_tbl2_yyyy = yyyy;
				ad_tbl2_mm   = 3;
				ad_tbl2_dd   = y2ktitu(ad_tbl2_yyyy,ad_tbl2_lon);
			}
			break;
		case 5:
			ad_tbl2_dd = y2rikka(ad_tbl2_yyyy,ad_tbl2_lon);
			if(ad_tbl2_dd > dd){
				ad_tbl2_lon  = lon;
				ad_tbl2_yyyy = yyyy;
				ad_tbl2_mm   = 4;
				ad_tbl2_dd   = y2seimei(ad_tbl2_yyyy,ad_tbl2_lon);
			}
			break;
		case 6:
			ad_tbl2_dd = y2bousyu(ad_tbl2_yyyy,ad_tbl2_lon);
			if(ad_tbl2_dd > dd){
				ad_tbl2_lon  = lon;
				ad_tbl2_yyyy = yyyy;
				ad_tbl2_mm   = 5;
				ad_tbl2_dd   = y2rikka(ad_tbl2_yyyy,ad_tbl2_lon);
			}
			break;
		case 7:
			ad_tbl2_dd = y2syusyo(ad_tbl2_yyyy,ad_tbl2_lon);
			if(ad_tbl2_dd > dd){
				ad_tbl2_lon  = lon;
				ad_tbl2_yyyy = yyyy;
				ad_tbl2_mm   = 6;
				ad_tbl2_dd   = y2bousyu(ad_tbl2_yyyy,ad_tbl2_lon);
			}
			break;
		case 8:
			ad_tbl2_dd = y2risyuu(ad_tbl2_yyyy,ad_tbl2_lon);
			if(ad_tbl2_dd > dd){
				ad_tbl2_lon  = lon;
				ad_tbl2_yyyy = yyyy;
				ad_tbl2_mm   = 7;
				ad_tbl2_dd   = y2syusyo(ad_tbl2_yyyy,ad_tbl2_lon);
			}
			break;
		case 9:
			ad_tbl2_dd = y2hakuro(ad_tbl2_yyyy,ad_tbl2_lon);
			if(ad_tbl2_dd > dd){
				ad_tbl2_lon  = lon;
				ad_tbl2_yyyy = yyyy;
				ad_tbl2_mm   = 8;
				ad_tbl2_dd   = y2risyuu(ad_tbl2_yyyy,ad_tbl2_lon);
			}
			break;
		case 10:
			ad_tbl2_dd = y2kanro(ad_tbl2_yyyy,ad_tbl2_lon);
			if(ad_tbl2_dd > dd){
				ad_tbl2_lon  = lon;
				ad_tbl2_yyyy = yyyy;
				ad_tbl2_mm   = 9;
				ad_tbl2_dd   = y2hakuro(ad_tbl2_yyyy,ad_tbl2_lon);
			}
			break;
		case 11:
			ad_tbl2_dd = y2rittou(ad_tbl2_yyyy,ad_tbl2_lon);
			if(ad_tbl2_dd > dd){
				ad_tbl2_lon  = lon;
				ad_tbl2_yyyy = yyyy;
				ad_tbl2_mm   = 10;
				ad_tbl2_dd   = y2kanro(ad_tbl2_yyyy,ad_tbl2_lon);
			}
			break;
		case 12:
			ad_tbl2_dd = y2taistu(ad_tbl2_yyyy,ad_tbl2_lon);
			if(ad_tbl2_dd > dd){
				ad_tbl2_lon  = lon;
				ad_tbl2_yyyy = yyyy;
				ad_tbl2_mm   = 11;
				ad_tbl2_dd   = y2rittou(ad_tbl2_yyyy,ad_tbl2_lon);
			}
			break;
		}

		// ߓ̌oߓZo
		JDChg  J  = new JDChg();
		Whi = (J.ad2jd(ad_tbl_yyyy,
					ad_tbl_mm,
					ad_tbl_dd,
					ad_tbl_time,
					ad_tbl_min,
					ad_tbl_sec,
					ad_tbl_lon) -
				J.ad2jd(ad_tbl2_yyyy,
					ad_tbl2_mm,
					ad_tbl2_dd,
					ad_tbl2_time,
					ad_tbl2_min,
					ad_tbl2_sec,
					ad_tbl2_lon));
		hi  = (int)Whi;

		return hi;
	}
}
