// ***************************************************************************
// * ^Cg   : Ⴄ Java                                      *
// * o[W : Ver2.0                                                     *
// * 쌠     : Copyright (c) 2000                                         *
// *        :  ÕF                                                    *
// * Ж     : čύH[                                               *
// *        : Ⴄ Java Ver2.0                               *
// *              T[o (Zpx@\j                                 *
// ***************************************************************************

// ***************************************************************************
// *                                                                         *
// *                             XV                                    *
// *                                                                         *
// * (C) Yoshihiko Hara    2000.06.22 ō쐬(ALMANAC2NXƗ)       *
// *                                                                         *
// ***************************************************************************
package shinodas.netUra.server.cal;

public class AlmCal{

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF AlmCal                                                *
	// *                                                                     *
	// *  @\      F RXgN^                                        *
	// *                                                                     *
	// *        F Ȃ                                                  *
	// *                                                                     *
	// *  o      F Ȃ                                                  *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.10.22    *
	// *                                                                     *
	// ***********************************************************************
	/**
		RXgN^B
	*/
	public AlmCal(){
		;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF rad2do                                                *
	// *                                                                     *
	// *  @\      F WApxiKjɕϊ                        *
	// *                                                                     *
	// *        F @ WA(double)                                   *
	// *                                                                     *
	// *  o      F @ x(double)                                         *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.05.14    *
	// *                                                                     *
	// ***********************************************************************
	/**
		WApxiKjɕϊB
		@param radi WAB
		@return pxiKjB
	*/
	public double rad2do(double radi){

		double kakudo; // ԋpl̕ҏW

		// ******************************
		// * WAxɕϊ鏈 *
		// ******************************
		kakudo = radi * 57.2957795;
		while(kakudo > 360){
			kakudo = kakudo - 360; // vZʂ360xzĂꍇ͕␳B
		}
		while(kakudo < 0){
			kakudo = kakudo + 360; // vZʂɂȂĂ܂ꍇ␳
		}                          // B

		return kakudo;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF do2rad                                                *
	// *                                                                     *
	// *  @\      F pxiKjWAɕϊ                        *
	// *                                                                     *
	// *        F @ x(double)                                         *
	// *                                                                     *
	// *  o      F @ WA(double)                                   *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.05.14    *
	// *                                                                     *
	// ***********************************************************************
	/**
		pxiKjWAɕϊB
		@param kakudo pxiKjB
		@return WAB
	*/
	public double do2rad(double kakudo){

		double radi; // ԋpl̕ҏW

		// ******************************
		// * xWAɕϊ鏈 *
		// ******************************
		radi = kakudo / 57.2957795;

		return radi;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF fns                                                   *
	// *                                                                     *
	// *  @\      F xłrhmZo                        *
	// *                                                                     *
	// *        F @ x(double)                                         *
	// *                                                                     *
	// *  o      F @ Ήrhml(double)                           *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.05.14    *
	// *                                                                     *
	// ***********************************************************************
	/**
		xłrhmZoB
		@param in_fns pxiKjB
		@return rhmlB
	*/
	public double fns(double in_fns){

		// ********************************
		// * ̓x0`360ɔ[߂鏈 *
		// ********************************
		in_fns = in_fns / 360.0;
		in_fns = in_fns - Math.floor(in_fns) + 1.0;
		in_fns = (in_fns - Math.floor(in_fns)) * 360.0;

		// **********************
		// * rhml̎Zo *
		// **********************
		in_fns = Math.sin(in_fns * 0.017453292519943);

		return in_fns;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF fnc                                                   *
	// *                                                                     *
	// *  @\      F xłbnrZo                        *
	// *                                                                     *
	// *        F @ x(double)                                         *
	// *                                                                     *
	// *  o      F @ Ήbnrl(double)                           *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.05.15    *
	// *                                                                     *
	// ***********************************************************************
	/**
		xłbnrZoB
		@param in_fnc pxiKjB
		@return bnrlB
	*/
	public double fnc(double in_fnc){

		// ********************************
		// * ̓x0`360ɔ[߂鏈 *
		// ********************************

		in_fnc = in_fnc / 360.0;
		in_fnc = in_fnc - Math.floor(in_fnc) + 1.0;
		in_fnc = (in_fnc - Math.floor(in_fnc)) * 360.0;

		// **********************
		// * bnrl̎Zo *
		// **********************
		in_fnc = Math.cos(in_fnc * 0.017453292519943);

		return in_fnc;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF jd2sok                                                *
	// *                                                                     *
	// *  @\      F EX瑾z̉o߂                      *
	// *                                                                     *
	// *        F EX(double)                                    *
	// *                                                                     *
	// *  o      F z̉o(double)                                    *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.10.13    *
	// *                                                                     *
	// ***********************************************************************
	/**
		EX瑾z̉o߂B
		@param jd EXB
		@return z̉oB
	*/
	public double jd2sok(double jd){

		double work_oukei;
		double t;

		t = (jd - 2451545.0) / 36525.0;

		work_oukei = 280.4659   + 36000.7695 * t;
		work_oukei = work_oukei + 1.9147     * fnc( 35999.05 * t + 267.52);
		work_oukei = work_oukei - 0.0048 * t * fnc( 35999.05 * t + 267.52);
		work_oukei = work_oukei + 0.0200     * fnc( 71998.1  * t + 265.1 );
		work_oukei = work_oukei + 0.0020     * fnc( 32964.0  * t + 158.0 );
		work_oukei = work_oukei + 0.0018     * fnc(    19.0  * t + 159.0 );
		work_oukei = work_oukei + 0.0018     * fnc(445267.0  * t + 208.0 );
		work_oukei = work_oukei + 0.0015     * fnc( 45038.0  * t + 254.0 );
		work_oukei = work_oukei + 0.0013     * fnc( 22519.0  * t + 352.0 );
		work_oukei = work_oukei + 0.0007     * fnc( 65929.0  * t +  45.0 );
		work_oukei = work_oukei + 0.0007     * fnc(  3035.0  * t + 110.0 );
		work_oukei = work_oukei + 0.0007     * fnc(  9038.0  * t +  64.0 );
		work_oukei = work_oukei + 0.0006     * fnc( 33718.0  * t + 316.0 );
		work_oukei = work_oukei + 0.0005     * fnc(   115.0  * t + 118.0 );
		work_oukei = work_oukei + 0.0005     * fnc(  2281.0  * t + 221.0 );
		work_oukei = work_oukei + 0.0004     * fnc( 29930.0  * t +  48.0 );
		work_oukei = work_oukei + 0.0004     * fnc( 31557.0  * t + 161.0 );

		// x0`360ɔ[߂邽߂̕␳sB
		work_oukei = work_oukei / 360.0;
		work_oukei = work_oukei  - Math.floor(work_oukei) + 1.0;
		work_oukei = (work_oukei - Math.floor(work_oukei)) * 360.0;
		return work_oukei;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF jd2mok                                                *
	// *                                                                     *
	// *  @\      F EX猎̉o߂                        *
	// *                                                                     *
	// *        F EX(double)                                    *
	// *                                                                     *
	// *  o      F ̉o(double)                                      *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.10.13    *
	// *                                                                     *
	// ***********************************************************************
	/**
		EX猎̉o߂B
		@param jd EXB
		@return ̉oB
	*/
	public double jd2mok(double jd){

		double work_oukei;
		double t;

		t = (jd - 2451545.0) / 36525.0;

		work_oukei = 218.3162   + 481267.8809 * t;
		work_oukei = work_oukei + 6.2888      * fnc(  477198.868 * t +  44.963);
		work_oukei = work_oukei + 1.274       * fnc(  413335.35  * t +  10.74 );
		work_oukei = work_oukei + 0.6583      * fnc(  890534.22  * t + 145.7  );
		work_oukei = work_oukei + 0.2136      * fnc(  954397.74  * t + 179.93 );
		work_oukei = work_oukei + 0.1851      * fnc(   35999.05  * t +  87.53 );
		work_oukei = work_oukei + 0.1144      * fnc(  966404.0   * t + 276.5  );
		work_oukei = work_oukei + 0.0588      * fnc(   63863.5   * t + 124.2  );
		work_oukei = work_oukei + 0.0571      * fnc(  377336.3   * t +  13.2  );
		work_oukei = work_oukei + 0.0533      * fnc( 1367733.1   * t + 280.7  );
		work_oukei = work_oukei + 0.0458      * fnc(  854535.2   * t + 148.2  );
		work_oukei = work_oukei + 0.0409      * fnc(  441199.8   * t +  47.4  );
		work_oukei = work_oukei + 0.0347      * fnc(  445267.1   * t +  27.9  );
		work_oukei = work_oukei + 0.0304      * fnc(  513197.9   * t + 222.5  );
		work_oukei = work_oukei + 0.0154      * fnc(   75870.0   * t +  41.0  );
		work_oukei = work_oukei + 0.0125      * fnc( 1443603.0   * t +  52.0  );
		work_oukei = work_oukei + 0.011       * fnc(  489205.0   * t + 142.0  );
		work_oukei = work_oukei + 0.0107      * fnc( 1303870.0   * t + 246.0  );
		work_oukei = work_oukei + 0.01        * fnc( 1431597.0   * t + 315.0  );
		work_oukei = work_oukei + 0.0085      * fnc(  826671.0   * t + 111.0  );
		work_oukei = work_oukei + 0.0079      * fnc(  449334.0   * t + 188.0  );
		work_oukei = work_oukei + 0.0068      * fnc(  926533.0   * t + 323.0  );
		work_oukei = work_oukei + 0.0052      * fnc(   31932.0   * t + 107.0  );
		work_oukei = work_oukei + 0.005       * fnc(  481266.0   * t + 205.0  );
		work_oukei = work_oukei + 0.004       * fnc( 1331734.0   * t + 283.0  );
		work_oukei = work_oukei + 0.004       * fnc( 1844932.0   * t +  56.0  );
		work_oukei = work_oukei + 0.004       * fnc(     133.0   * t +  29.0  );
		work_oukei = work_oukei + 0.0038      * fnc( 1781068.0   * t +  21.0  );
		work_oukei = work_oukei + 0.0037      * fnc(  541062.0   * t + 259.0  );
		work_oukei = work_oukei + 0.0028      * fnc(    1934.0   * t + 145.0  );
		work_oukei = work_oukei + 0.0027      * fnc(  918399.0   * t + 182.0  );
		work_oukei = work_oukei + 0.0026      * fnc( 1379739.0   * t +  17.0  );
		work_oukei = work_oukei + 0.0024      * fnc(   99863.0   * t + 122.0  );
		work_oukei = work_oukei + 0.0023      * fnc(  922466.0   * t + 163.0  );
		work_oukei = work_oukei + 0.0022      * fnc(  818536.0   * t + 151.0  );
		work_oukei = work_oukei + 0.0021      * fnc(  990397.0   * t + 357.0  );
		work_oukei = work_oukei + 0.0021      * fnc(   71998.0   * t +  85.0  );
		work_oukei = work_oukei + 0.0021      * fnc(  341337.0   * t +  16.0  );
		work_oukei = work_oukei + 0.0018      * fnc(  401329.0   * t + 274.0  );
		work_oukei = work_oukei + 0.0016      * fnc( 1856938.0   * t + 152.0  );
		work_oukei = work_oukei + 0.0012      * fnc( 1267871.0   * t + 249.0  );
		work_oukei = work_oukei + 0.0011      * fnc( 1920802.0   * t + 186.0  );
		work_oukei = work_oukei + 0.0009      * fnc(  858602.0   * t + 129.0  );
		work_oukei = work_oukei + 0.0008      * fnc( 1403732.0   * t +  98.0  );
		work_oukei = work_oukei + 0.0007      * fnc(  790672.0   * t + 114.0  );
		work_oukei = work_oukei + 0.0007      * fnc(  405201.0   * t +  50.0  );
		work_oukei = work_oukei + 0.0007      * fnc(  485333.0   * t + 186.0  );
		work_oukei = work_oukei + 0.0007      * fnc(   27864.0   * t + 127.0  );
		work_oukei = work_oukei + 0.0006      * fnc(  111869.0   * t +  38.0  );
		work_oukei = work_oukei + 0.0006      * fnc( 2258267.0   * t + 156.0  );
		work_oukei = work_oukei + 0.0005      * fnc( 1908795.0   * t +  90.0  );
		work_oukei = work_oukei + 0.0005      * fnc( 1745069.0   * t +  24.0  );
		work_oukei = work_oukei + 0.0005      * fnc(  509131.0   * t + 242.0  );
		work_oukei = work_oukei + 0.0004      * fnc(   39871.0   * t + 223.0  );
		work_oukei = work_oukei + 0.0004      * fnc(   12006.0   * t + 187.0  );
		work_oukei = work_oukei + 0.0003      * fnc(  958465.0   * t + 340.0  );
		work_oukei = work_oukei + 0.0003      * fnc(  381404.0   * t + 354.0  );
		work_oukei = work_oukei + 0.0003      * fnc(  349472.0   * t + 337.0  );
		work_oukei = work_oukei + 0.0003      * fnc( 1808933.0   * t +  58.0  );
		work_oukei = work_oukei + 0.0003      * fnc(  549197.0   * t + 220.0  );
		work_oukei = work_oukei + 0.0003      * fnc(    4067.0   * t +  70.0  );
		work_oukei = work_oukei + 0.0003      * fnc( 2322131.0   * t + 191.0  );

		// x0`360ɔ[߂邽߂̕␳sB
		work_oukei = work_oukei / 360.0;
		work_oukei = work_oukei - Math.floor(work_oukei) + 1.0;
		work_oukei = (work_oukei - Math.floor(work_oukei)) * 360.0;
		return work_oukei;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF fmod                                                  *
	// *                                                                     *
	// *  @\      F 폜Ŋ̏]߂B                *
	// *                                                                     *
	// *        F @폜(double)                                      *
	// *               A(double)                                        *
	// *                                                                     *
	// *  o      F ](double)                                          *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.10.17    *
	// *                                                                     *
	// ***********************************************************************
	/**
		폜Ŋ̏]߂B
		@param f1 폜B
		@param f2 B
		@return ]B
	*/
	public double fmod(double f1, double f2){

		double wf1;
		double wf2;
		double counter;
		double ret;

		// ޔB
		wf1 = f1;
		wf2 = f2;

		for(counter = 0.0; wf1 > 0; ){
			wf1 = wf1 - wf2;
			if( wf1 >= 0) counter += 1.0;
		}
		ret = f1 - (f2 * counter);
        
		return ret;
	}
}
